derive-2.5.23: A program and library to derive instances for data types

Safe Haskell | None
Language | Haskell98

Data.Derive.Internal.Derivation

# Documentation

data Derivation Source

Constructors

Derivation |

Fields

derivationName :: String
derivationOp :: Type -> (String -> Decl) -> FullDataDecl -> Either String [Decl]

derivationParams :: String -> ([Type] -> (String -> Decl) -> FullDataDecl -> Either String [Decl]) -> Derivation Source

derivationCustom :: String -> (FullDataDecl -> Either String [Decl]) -> Derivation Source

derivationDSL :: String -> DSL -> Derivation Source

derivationCustomDSL :: String -> (FullDataDecl -> [Decl] -> [Decl]) -> DSL -> Derivation Source

customSplice :: (FullDataDecl -> Exp -> Exp) -> FullDataDecl -> [Decl] -> [Decl] Source

customContext :: (FullDataDecl -> Context -> Context) -> FullDataDecl -> [Decl] -> [Decl] Source